/*
 --------------------------------------------------------------------------
 ITU-T G.720.1 Source Code
 Software Release 1.1a (2010-10)
 (C) 2009 Huawei Technologies Co., LTD. 
 --------------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <memory.h>
#include "wmops.h"
#include "commandpars.h"
#include "preproc_fx.h"
#include "vad_fx.h"
#include "smd_fx.h"
#include "stl_fx.h"

#ifdef WMOPS_FX
#ifdef DETAIL
Word16 restId = -1;
Word16 fftId = -1;
Word16 hp_winId = -1;
Word16 rmsId = -1;
Word16 zcrId = -1;
Word16 dzcrId = -1;
Word16 ssnrId = -1;
Word16 TonalityId = -1;
Word16 spdevId = -1;
Word16 bcgUpdtId = -1;
Word16 lsnrId = -1;
Word16 MusBcgdId = -1;
Word16 bcgStaId = -1;
#ifndef GVAD
if (!mode)
{
	int fluxId = -1;
	int hpId = -1;
	int smd_coreId = -1;
}
#endif
#else
int restId = -1;
#endif
#endif


void main(Word16 argc, char *argv[])
{
    FILE *f_speech = NULL;                 /* File of speech data     */
    FILE *f_output = NULL;                 /* File of decision result */
#ifndef GVAD
    smdState_fx *smdSt_fx;	
    Word16 smd_flag;
    Word16 sid_flag;
    Word16 sad_flag;
    Word16 mode;
#endif	
    vadState_fx *vadSt_fx;
    Word16 SigFpw_fx[FFTSIZE16k];
    Word16 vad_flg;
    Word32 frame;
    Word16 frame_size;
    Word16 nb;                                                
    Word16 op;	
    Word16 mssnr_fx;
    Word16 *signal_buffer,*signal_buffer_ptr;
    Word8 *output;
    Word32 fsize;
    Word32 j;
    Word16 fft_exp_fx;
		
#ifndef GVAD
    fsize= getcommandpars(argc, argv, &nb, &frame_size, &mode, &op, &f_speech, &f_output);
#else
    fsize= getcommandpars(argc, argv, &nb, &frame_size, &op, &f_speech, &f_output);
#endif
    
    printf("\nfsize = %ld\n",fsize);
		
#ifndef GVAD
    printf("Code compiled for GSAD mode.");
    if (mode==0) 
    {
      printf(" Code runs in GSAD mode.\n");
    }
    else 
    {
      printf(" Code runs in VAD mode.\n");
    }
#else
    printf("Code compiled for and runs in VAD mode.");
#endif

    switch (op) 
    {
    case 0: 
      printf("Balanced operating point\n");
      break;
    case 1: 
      printf("Quality-preferred operating point\n");
      break;
    case 2: 
      printf("Bandwidth-saving operating point\n");
      break;
    }
#ifdef WMOPS_FX
#ifdef DETAIL
	
    rmsId=getCounterId("rms"); 
    setCounter(rmsId); 
    Init_WMOPS_FX_counter ();
	
    hp_winId=getCounterId("hp_win"); 
    setCounter(hp_winId); 
    Init_WMOPS_FX_counter ();
	
    fftId=getCounterId("fft"); 
    setCounter(fftId); 
    Init_WMOPS_FX_counter (); 
	
    zcrId=getCounterId("zcr"); 
    setCounter(zcrId); 
    Init_WMOPS_FX_counter (); 
	
    dzcrId=getCounterId("dzcr"); 
    setCounter(dzcrId); 
    Init_WMOPS_FX_counter (); 
	
    ssnrId=getCounterId("ssnr"); 
    setCounter(ssnrId); 
    Init_WMOPS_FX_counter (); 
	
    TonalityId=getCounterId("Tonality"); 
    setCounter(TonalityId); 
    Init_WMOPS_FX_counter (); 
	
    spdevId=getCounterId("spdev"); 
    setCounter(spdevId); 
    Init_WMOPS_FX_counter ();
	
    bcgUpdtId=getCounterId("bcgUpdt"); 
    setCounter(bcgUpdtId); 
    Init_WMOPS_FX_counter ();
	
    lsnrId=getCounterId("lsnr"); 
    setCounter(lsnrId); 
    Init_WMOPS_FX_counter ();
	
    MusBcgdId=getCounterId("MusBcgd"); 
    setCounter(MusBcgdId); 
    Init_WMOPS_FX_counter ();
	
    bcgStaId=getCounterId("bcgSta"); 
    setCounter(bcgStaId); 
    Init_WMOPS_FX_counter ();
	
#ifndef GVAD
    if (!mode)
    {
      fluxId=getCounterId("flux"); 
      setCounter(bcgStaId); 
      Init_WMOPS_FX_counter ();

      hpId=getCounterId("hp"); 
      setCounter(bcgStaId); 
      Init_WMOPS_FX_counter ();
    
      smd_coreId=getCounterId("smd_core"); 
      setCounter(bcgStaId); 
      Init_WMOPS_FX_counter ();
    }
#endif	
    restId=getCounterId("Rest of code"); 
    setCounter(restId); 
    Init_WMOPS_FX_counter (); 
#else
    restId=getCounterId("Rest of code"); 
    setCounter(restId); 
    Init_WMOPS_FX_counter (); 
#endif
#endif

    vad_init_fx(&vadSt_fx);

#ifndef GVAD
    /* smd state initialization */
    if (!mode)
    {
      smd_init_fx(&smdSt_fx, nb);
    }
#endif
	
    fprintf(stderr, "\n --- Running ---\n");
	
    if ((signal_buffer_ptr=calloc(fsize, sizeof(Word16)))==NULL)
    {
      printf("Can't allocate enough memory\n");
      exit(0);
    }
    signal_buffer = signal_buffer_ptr;
    fread(signal_buffer, sizeof(Word16), fsize, f_speech);
	
    if ((output=calloc((fsize/frame_size), sizeof(unsigned char)))==NULL) 
    {
      printf("Can't allocate enough memory\n");
      exit(0);
    }
		
    frame = 0;	
    for (j=0 ; j < (fsize/frame_size) ; j++)
    {		
#ifdef WMOPS_FX
#ifdef DETAIL
      setCounter(rmsId); 
      fwc();
      Reset_WMOPS_FX_counter();
		
      setCounter(hp_winId); 
      fwc();
      Reset_WMOPS_FX_counter();
		
      setCounter(fftId); 
      fwc();
      Reset_WMOPS_FX_counter();		
		
      setCounter(zcrId); 
      fwc();
      Reset_WMOPS_FX_counter();
		
      setCounter(dzcrId); 
      fwc();
      Reset_WMOPS_FX_counter();		
		
      setCounter(ssnrId); 
      fwc();
      Reset_WMOPS_FX_counter();
		
      setCounter(TonalityId); 
      fwc();
      Reset_WMOPS_FX_counter();
		
      setCounter(spdevId); 
      fwc();
      Reset_WMOPS_FX_counter();
		
      setCounter(bcgUpdtId); 
      fwc();
      Reset_WMOPS_FX_counter();
		
      setCounter(lsnrId); 
      fwc();
      Reset_WMOPS_FX_counter();
		
      setCounter(MusBcgdId); 
      fwc();
      Reset_WMOPS_FX_counter();
		
      setCounter(bcgStaId); 
      fwc();
      Reset_WMOPS_FX_counter();

#ifndef GVAD
      if (!mode)
      {
        setCounter(fluxId); 
        fwc();
        Reset_WMOPS_FX_counter();

        setCounter(hpId); 
        fwc();
        Reset_WMOPS_FX_counter();

        setCounter(smd_coreId); 
        fwc();
        Reset_WMOPS_FX_counter();
      }
#endif		
      setCounter(restId); 
      fwc();
      Reset_WMOPS_FX_counter();
		
#else
      setCounter(restId); 
      fwc();
      Reset_WMOPS_FX_counter();
#endif
#endif
		
#ifdef DRAM
      accDRAM(FRAME_RESET, 0);
#ifndef GVAD
      if (!mode)
      {
        accDRAM(FRAME_COUNT, 1344); 
      }
      else
      {
        accDRAM(FRAME_COUNT, 920);
      }                  
#else
      accDRAM(FRAME_COUNT, 920);                   
#endif
#endif	
      frame++;		
      fprintf(stderr, "Frames processed: %ld\r", frame);      		
      preproc_fx(signal_buffer, SigFpw_fx, &fft_exp_fx,nb, vadSt_fx);		
      vad_flg = vad_fx(signal_buffer, vadSt_fx, SigFpw_fx, &fft_exp_fx, op, nb, &mssnr_fx); 
				
#ifndef GVAD		
      if (!mode)
      {
        smd_flag = smd_fx(smdSt_fx, SigFpw_fx, fft_exp_fx, vad_flg, mssnr_fx, op, nb);                                                                                                      			
        sid_flag = sid_fx(vadSt_fx);			
        sad_flag = sad_output(vad_flg, smd_flag, sid_flag);			
        output[frame-1] = (Word8)sad_flag;			
      }
      else
      {
        if (vad_flg==1) 
        {
          vad_flg = 3;
        }
        output[frame - 1] = (Word8)vad_flg;
      }		
#else		
      output[frame - 1] = (Word8)vad_flg;		
#endif		
      signal_buffer += frame_size;
    }
#ifdef DRAM
    fprintf(stderr, "Max value of DRAM  %d Words\n", accDRAM(DRAM_REPORT,0));
#endif	
    fwrite(output, sizeof(Word8), (fsize/frame_size), f_output);	
    vad_exit_fx(&vadSt_fx);
	
#ifndef GVAD
    if (!mode)
    {
      smd_exit_fx(&smdSt_fx);
    }
#endif
		
#ifdef WMOPS_FX
#ifdef DETAIL
    setCounter(rmsId); 
    fwc();
    printf("rms complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
	
    setCounter(hp_winId); 
    fwc();
    printf("hp_win complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
	
    setCounter(fftId); 
    fwc();
    printf("FFT complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
	
    setCounter(zcrId); 
    fwc();
    printf("zcr complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
	
    setCounter(dzcrId); 
    fwc();
    printf("dzcr complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
		
    setCounter(ssnrId); 
    fwc();
    printf("ssnr complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
	
    setCounter(TonalityId); 
    fwc();
    printf("Tonality complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
	
    setCounter(spdevId); 
    fwc();
    printf("spdev complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
	
    setCounter(bcgUpdtId); 
    fwc();
    printf("bcgUpdate complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
	
    setCounter(lsnrId); 
    fwc();
    printf("lsnr complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
	
    setCounter(MusBcgdId); 
    fwc();
    printf("MusBcgd complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
	
    setCounter(bcgStaId); 
    fwc();
    printf("bcgSta complexity\n");
    WMOPS_FX_output(0);
    printf("\n");

#ifndef GVAD
    if (!mode)
    {
      setCounter(fluxId); 
      fwc();
      printf("Flux complexity\n");
      WMOPS_FX_output(0);
      printf("\n");
      
      setCounter(hpId); 
      fwc();
      printf("Peakiness complexity\n");
      WMOPS_FX_output(0);
      printf("\n");

      setCounter(smd_coreId); 
      fwc();
      printf("smd_core complexity\n");
      WMOPS_FX_output(0);
      printf("\n");
}
#endif
    setCounter(restId); 
    fwc();
    printf("Rest complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
#else
    setCounter(restId); 
    fwc();
    printf("Rest complexity\n");
    WMOPS_FX_output(0);
    printf("\n");
#endif
#endif	
    free(signal_buffer_ptr);
    free(output);	
    fclose(f_speech);
    fclose(f_output);
}
